<?php
/**
 * @package		HikaShop for Joomla!
 * @version		1.4.6
 * @author		hikashop.com
 * @copyright	(C) 2010 HIKARI SOFTWARE. All rights reserved.
 * @license		http://www.hikashop.com/commercial_license.php
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgHikashoppaymentSystempay extends JPlugin
{
	var $accepted_currencies = array(
		"AUD" => "036", //Dollar australien
		"CAD" => "124", //Dollar canadien
		"CNY" => "156", //Renminbi yuan chinois
		"DKK" => "208", //Couronne danoise
		"JPY" => "392", //Yen
		"SEK" => "752", //Couronne suédoise
		"CHF" => "756", //Franc suisse
		"GBP" => "826", //Livre sterling
		"USD" => "840", //Dollar des États-Unis
            "EUR" => "978"  //Euro   
	);
    var $debugData = array();
    function onPaymentDisplay(&$order,&$methods,&$usable_methods){
    	if(!empty($methods)){
    		foreach($methods as $method){
				if($method->payment_type!='systempay'){
					continue;
				}
				if(!empty($method->payment_zone_namekey)){
					$zoneClass=hikashop::get('class.zone');
	    			$zones = $zoneClass->getOrderZones($order);
					if(!in_array($method->payment_zone_namekey,$zones)){
						return true;
					}
				}
				$currencyClass = hikashop::get('class.currency');
				$null=null;
				$currency_id = intval(@$order->total->prices[0]->price_currency_id);
				$currency = $currencyClass->getCurrencies($currency_id,$null);
				if(!empty($currency) && !in_array(@$currency[$currency_id]->currency_code,$this->accepted_currencies)){
					return true;
				}
				$usable_methods[$method->ordering]=$method;
    		}
    	}
    	return true;
    }
    function onPaymentSave(&$cart,&$rates,&$payment_id){
    	$usable = array();
    	$this->onPaymentDisplay($cart,$rates,$usable); 
    	$payment_id = (int) $payment_id;
    	foreach($usable as $usable_method){
    		if($usable_method->payment_id==$payment_id){
    			return $usable_method;
    		}
    	}
    	return false;
    }
    function onAfterOrderConfirm(&$order,&$methods,$method_id){
    	$method =& $methods[$method_id];
		$tax_total = '';
		$discount_total = '';
		$currencyClass = hikashop::get('class.currency');
		$currencies=null;
		$currencies = $currencyClass->getCurrencies($order->order_currency_id,$currencies);
		$currency=$currencies[$order->order_currency_id];
		$user = hikashop::loadUser(true);
		$vars = Array(		
		"capture_delay" =>'',
		"payment_cards"=>'',
		"payment_config"=>'',
		'order_id'=>$order->order_id,
		"currency" => @$this->accepted_currencies[$currency->currency_code],
		"amount" => str_replace(array('.',','),'',round($order->cart->full_total->prices[0]->price_value_with_tax,(int)$currency->currency_locale['int_frac_digits'])),
		);
		$vars["cust_email"]=$user->user_email;
		$vars["cust_id"]=$user->user_id;
		$vars["site_id"]=$method->payment_params->site_id;
		if(!empty($method->payment_params->test)){
			$vars["ctx_mode"]='TEST';
		}else{
			$vars["ctx_mode"]='PRODUCTION';
		}
		$lang = &JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));
		$notify_url = hikashop::completeLink('checkout&task=notify&notif_payment=paypal&tmpl=component&lang='.$locale);
		$vars['url_return']=$notify_url;
		if(empty($method->payment_params->return_url)){
			$return_url = hikashop::completeLink('checkout&task=after_end&order_id='.$order->order_id);
		}else{
			$return_url = $method->payment_params->return_url;
		}
		$vars['url_success']=$return_url;
		$cancel_url =hikashop::completeLink('order&task=cancel_order&order_id='.$order->order_id);
		$vars['url_referral']=$cancel_url;
		$vars['url_refused']=$cancel_url;
		$vars['url_cancel']=$cancel_url;
		$vars['url_error']=$cancel_url;
		if(!in_array($locale,array('en', 'de', 'es', 'fr', 'it', 'zh', 'jp'))) $locale = 'en';
		$vars["language"]=$locale;
		$app =& JFactory::getApplication();
		$cart = hikashop::get('class.cart');
		$address=$app->getUserState( HIKASHOP_COMPONENT.'.shipping_address');
		$type = 'shipping';
		if(empty($address)){
	    	$address=$app->getUserState( HIKASHOP_COMPONENT.'.billing_address');
			if(!empty($address)){
				$type='billing';
			}
		}
		if(!empty($address)){
			$cart->loadAddress($order->cart,$address,'object',$type);
			$address_type = $type.'_address';
			$vars["cust_name"]=@$order->cart->$address_type->address_firstname.' '.@$order->cart->$address_type->address_lastname;
			$vars["cust_title"]=@$order->cart->$address_type->address_title;
			$vars["cust_address"]=@$order->cart->$address_type->address_street;
			$vars["cust_zip"]=@$order->cart->$address_type->address_post_code;
			$vars["cust_city"]=@$order->cart->$address_type->address_city;
			$vars["cust_phone"]=@$order->cart->$address_type->address_telephone;
			$vars["cust_country"]=@$order->cart->$address_type->address_country->zone_code_2;
		}
		$vars['contrib']='HikaShop';
		$vars['version']='V1';
		$vars['trans_date']=gmdate('YmdHis',time());
		list($usec, $sec) = explode(" ", microtime());
		$temp = ($this->timestamp + $usec - strtotime('today 00:00')) * 10;
		$vars['trans_id'] = sprintf('%06d',$temp);
		$vars['validation_mode']='';
		$vars["signature"]=sha1($vars['version'].'+'.$vars["site_id"].'+'.$vars["ctx_mode"].'+'.$vars["trans_id"]
		.'+'.$vars["trans_date"].'+'.$vars["validation_mode"].'+'.$vars["capture_delay"].'+'.$vars["payment_config"]
		.'+'.$vars["payment_cards"].'+'.$vars["amount"].'+'.$vars["currency"].'+'.$method->payment_params->certificate);
		JHTML::_('behavior.mootools');
		$app =& JFactory::getApplication();
		$name = $method->payment_type.'_end.php';
    	$path = JPATH_THEMES.DS.$app->getTemplate().DS.'hikashoppayment'.DS.$name;
    	if(!file_exists($path)){
    		if(version_compare(JVERSION,'1.6','<')){
    			$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$name;
    		}else{
    			$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$method->payment_type.DS.$name;
    		}
    		if(!file_exists($path)){
    			return true;
    		}
    	}
    	require($path);
    	return true;
    }
    function onPaymentNotification(&$statuses){
    	$pluginsClass = hikashop::get('class.plugins');
		$elements = $pluginsClass->getMethods('payment','systempay');
		if(empty($elements)) return false;
		$element = reset($elements);
    	$vars = array();
    	$data = array();
    	$filter = & JFilterInput::getInstance();
    	foreach($_POST as $key => $value){
    		$key = $filter->clean($key);
    		$value = JRequest::getString($key);
    		$vars[$key]=$value;
    	}
    	$vars['calculated_signature'] = sha1(@$vars['version'].'+'.@$vars["site_id"].'+'.@$vars["ctx_mode"].'+'.@$vars["trans_id"]
		.'+'.@$vars["trans_date"].'+'.@$vars["validation_mode"].'+'.@$vars["capture_delay"].'+'.@$vars["payment_config"]
		.'+'.@$vars["card_brand"].'+'.@$vars["card_number"].'+'.@$vars["amount"].'+'.@$vars["currency"]
		.'+'.@$vars["auth_mode"].'+'.@$vars["auth_result"].'+'.@$vars["auth_number"].'+'.@$vars["warranty_result"]
		.'+'.@$vars["payment_certificate"].'+'.@$vars["result"].'+'.@$vars["hash"].'+'.$element->payment_params->certificate);
		if($element->payment_params->debug){
			echo print_r($vars,true)."\n\n\n";
		}    	
		$orderClass = hikashop::get('class.order');
		$dbOrder = $orderClass->get((int)@$vars['order_id']);
		$order = null;
		$order->order_id = @$dbOrder->order_id;
		if(!empty($dbOrder)){
			$order->old_status->order_status=$dbOrder->order_status;
			$url = hikashop::completeLink('order&task=edit&order_id='.$order->order_id);
			$order_text = "\r\n".JText::sprintf('NOTIFICATION_OF_ORDER_ON_WEBSITE',hikashop::encode($dbOrder),HIKASHOP_LIVE);
			$order_text .= "\r\n".str_replace('<br/>',"\r\n",JText::sprintf('ACCESS_ORDER_WITH_LINK',$url));
		}else{
			echo "Could not load any order for your notification ".@$vars['order_id'];
			return false;
		}
		if($element->payment_params->debug){
			echo print_r($dbOrder,true)."\n\n\n";
		}    
		$mailer =& JFactory::getMailer();
		$config =& hikashop::config();
		$sender = array( 
		    $config->get('from_email'),
		    $config->get('from_name') );
		$mailer->setSender($sender);
		$mailer->addRecipient(explode(',',$config->get('payment_notification_email')));
	    if ($vars['calculated_signature']!=@$vars['signature']) {
	    	$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','SystemPay').'invalid response');
			$body = JText::sprintf("Hello,\r\n A SystemPay notification was refused because the response from the SystemPay server was invalid")."\r\n\r\n".$order_text;
			$mailer->setBody($body);
			$mailer->Send();
			if($element->payment_params->debug){
				echo 'invalid response'."\n\n\n";
			} 
    		return false;
	    }
	    $vars['result']=@$vars['result'];
		if(!in_array($vars['result'],array("00"))) {
			$vars['payment_status']='Cancelled';
			$body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS','SystemPay',$vars['payment_status'])).' '.JText::_('STATUS_NOT_CHANGED')."\r\n\r\n".$order_text;
		 	$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION','SystemPay',$vars['payment_status']));
			$mailer->setBody($body);
			$mailer->Send();
			if($element->payment_params->debug){
				echo 'payment with code '.$vars['result'].(!empty($vars['extra_result'])?' : '.@$vars['extra_result']:'')."\n\n\n";
			} 
			return false;
		 }
		$order->history->history_reason=JText::sprintf('AUTOMATIC_PAYMENT_NOTIFICATION');
		$order->history->history_notified=0;
		$order->history->history_amount=@$vars['amount'].@$vars['currency'];
		$order->history->history_payment_id = $element->payment_id;
		$order->history->history_payment_method =$element->payment_type;
		$order->history->history_data = ob_get_clean();
		$order->history->history_type = 'payment';
 		$order->order_status = $element->payment_params->verified_status;
 		$vars['payment_status']='Accepted';
 		$order->history->history_notified=1;
	 	$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION','SystemPay',$vars['payment_status']));
		$body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS','SystemPay',$vars['payment_status'])).' '.JText::sprintf('ORDER_STATUS_CHANGED',$statuses[$order->order_status])."\r\n\r\n".$order_text;
		$mailer->setBody($body);
		$mailer->Send();
	 	$orderClass->save($order);
    	return true;
    }
    function onPaymentConfiguration(&$element){
	    	$this->systempay = JRequest::getCmd('name','systempay');  
			if(empty($element)){
				$element = null;
	    		$element->payment_name='SystemPay';
	    		$element->payment_description='Vous pouvez payer par carte bleue avec ce système de paiement';
	    		$element->payment_images='MasterCard,VISA,Credit_card,American_Express';
	    		$element->payment_type=$this->systempay;
	    		$element->payment_params=null;
	    		$list=null;
	    		$element->payment_params->invalid_status='cancelled';
	    		$element->payment_params->pending_status='created';
	    		$element->payment_params->verified_status='confirmed';
	    		$element = array($element);
	    	}
	    	$bar = & JToolBar::getInstance('toolbar');
			JToolBarHelper::save();
			JToolBarHelper::apply();
			JToolBarHelper::cancel();
			JToolBarHelper::divider();
			$bar->appendButton( 'Pophelp','payment-systempay-form');
			hikashop::setTitle('SystemPay','plugin','plugins&plugin_type=payment&task=edit&name='.$this->systempay);
			$app =& JFactory::getApplication();
			$app->setUserState( HIKASHOP_COMPONENT.'.payment_plugin_type', $this->systempay);
			$this->address = hikashop::get('type.address');
			$this->category = hikashop::get('type.categorysub');
			$this->category->type = 'status';
    }
    function onPaymentConfigurationSave(&$element){
		return true;
    }
}
